    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------------
    028     * XYCoordinateType.java
    029     * ---------------------
    030     * (C) Copyright 2007, 2008 by Object Refinery Limited and Contributors.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes
    036     * -------
    037     * 02-Feb-2007 : Version 1 (DG);
    038     * 03-Sep-2008 : Moved from experimental to main (DG);
    039     *
    040     */
    041
    042    package org.jfree.chart.util;
    043
    044    import java.io.ObjectStreamException;
    045    import java.io.Serializable;
    046
    047    /**
    048     * Represents several possible interpretations for an (x, y) coordinate.
    049     *
    050     * @since 1.0.11
    051     */
    052    public final class XYCoordinateType implements Serializable {
    053
    054        /** The (x, y) coordinates represent a point in the data space. */
    055        public static final XYCoordinateType DATA
    056                = new XYCoordinateType("XYCoordinateType.DATA");
    057
    058        /**
    059         * The (x, y) coordinates represent a relative position in the data space.
    060         * In this case, the values should be in the range (0.0 to 1.0).
    061         */
    062        public static final XYCoordinateType RELATIVE
    063                = new XYCoordinateType("XYCoordinateType.RELATIVE");
    064
    065        /**
    066         * The (x, y) coordinates represent indices in a dataset.
    067         * In this case, the values should be in the range (0.0 to 1.0).
    068         */
    069        public static final XYCoordinateType INDEX
    070                = new XYCoordinateType("XYCoordinateType.INDEX");
    071
    072        /** The name. */
    073        private String name;
    074
    075        /**
    076         * Private constructor.
    077         *
    078         * @param name  the name.
    079         */
    080        private XYCoordinateType(String name) {
    081            this.name = name;
    082        }
    083
    084        /**
    085         * Returns a string representing the object.
    086         *
    087         * @return The string.
    088         */
    089        public String toString() {
    090            return this.name;
    091        }
    092
    093        /**
    094         * Returns <code>true</code> if this object is equal to the specified
    095         * object, and <code>false</code> otherwise.
    096         *
    097         * @param obj  the other object.
    098         *
    099         * @return A boolean.
    100         */
    101        public boolean equals(Object obj) {
    102            if (this == obj) {
    103                return true;
    104            }
    105            if (!(obj instanceof XYCoordinateType)) {
    106                return false;
    107            }
    108            XYCoordinateType order = (XYCoordinateType) obj;
    109            if (!this.name.equals(order.toString())) {
    110                return false;
    111            }
    112            return true;
    113        }
    114
    115        /**
    116         * Ensures that serialization returns the unique instances.
    117         *
    118         * @return The object.
    119         *
    120         * @throws ObjectStreamException if there is a problem.
    121         */
    122        private Object readResolve() throws ObjectStreamException {
    123            if (this.equals(XYCoordinateType.DATA)) {
    124                return XYCoordinateType.DATA;
    125            }
    126            else if (this.equals(XYCoordinateType.RELATIVE)) {
    127                return XYCoordinateType.RELATIVE;
    128            }
    129            else if (this.equals(XYCoordinateType.INDEX)) {
    130                return XYCoordinateType.INDEX;
    131            }
    132            return null;
    133        }
    134
    135    }